library Rc5Com;
//The Rc5Com.DLL
//By E.L. Lagerburg januari 2002.
//Beta 1

uses
  Windows;

{$R *.RES}


Type TRc5Code = Record
                  ErrorCode:Integer;
                  Rc5Type:Integer;
                  Toggle:Integer;
                  Address:Integer;
                  Command:Integer;
                End;

Const Rc5Empty:TRc5Code = (
                           ErrorCode:-1; //Port not open
                           Rc5Type: 0;
                           Toggle: 0;
                           Address:0;
                           Command:0
                           );


Type TIrEvent = Array[0..27] of Integer;

Const IrEventEmpty:TIrEvent = (0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0);


Const Rc5Time = 24889;   //us
Const Rc5BitTime = Rc5Time div 14;
Const Rc5HalfBitTime = Rc5Time div 28;
Const Rc5QbitTime = Rc5Time div 56;

Const CommOpen:Boolean = False;
Const Frec:Int64 = 0;
Const PrevCount:Int64 = 0;


Const fDtrControlEnable    =   16;        // DTR flow control type       $0010
Const fRtsControlEnable    = 4096;        // RTS flow control            $1000

//Progamming codes for he PHILIPS universal remote control sbc RU660/00
Const RU660ToRc5Commands:Array[4..11,0..7] of Integer = (
                                                        (15,12,13,10,11, 8, 9,14),
                                                        ( 7, 4, 5, 2, 3, 0, 1, 6),
                                                        (31,28,29,26,27,24,25,30),
                                                        (23,20,21,18,19,16,17,22),
                                                        (47,44,45,42,43,40,41,46),
                                                        (39,36,37,34,35,32,33,38),
                                                        (63,60,61,58,59,56,57,62),
                                                        (55,52,53,50,51,48,49,54)
                                                        );

Const Rc5ToRU660Commands:Array[0..63] of Integer = (165,197,101,133, 37, 69,229,  5,
                                                    164,196,100,132, 36, 68,228,  4,
                                                    167,199,103,135, 39, 71,231,  7,
                                                    166,198,102,134, 38, 70,230,  6,
                                                    169,201,105,137, 41, 73,233,  9,
                                                    168,200,104,136, 40, 72,232,  8,
                                                    171,203,107,139, 43, 75,235, 11,
                                                    170,202,106,138, 42, 74,234, 10);

//Programming PHILIPS universal remote control sbc RU660/00
//Press mode selector to select the categorie to programm for  TV,VCR,SAT ...
//Press and hold the key 1 and the 6 at the same time for about 3 seconds
//until greed led light up
//Press 9 9 4
//enter 3 digit command code (see functions in this DLL / not the same as Rc5 command code)
//Press the key to programm
//does not override macro's so delete this first for the key to program


Var CommHandle:THandle;

Procedure InitIrDelay;StdCall;
Begin
  QueryPerformanceFrequency(Frec);
  QueryPerformanceCounter(PrevCount);
End;


Procedure IrDelay(uS:Integer);StdCall;
Var Einde,C:Int64;
Begin
  Einde:=PrevCount+Round((uS*Frec)/1000000);
  Repeat
    QueryPerformanceCounter(C);
  Until C >= Einde;
  PrevCount:=Einde;
End;

Function CTSLine:Integer;
Var ModemStat:DWORD;
Begin
  GetCommModemStatus(CommHandle,ModemStat);
  Result:=Integer((ModemStat and MS_CTS_ON) = MS_CTS_ON);
End;

////!!!!!!!!!!!!!!!!!!
Procedure TXDLine(CommHandle:THandle;State:integer); //Not tested yet no hardware
begin
 if (State=0)then ClearCommBreak(CommHandle)
  else SetCommBreak(CommHandle);
end;
//////!!!!!!!!!!!!!!!!!



Function RU660ToRc5Command(RU660:Integer):TRc5Code;StdCall;
Var Kol,Row:Integer;
Begin
  Result:=Rc5Empty;
  if (RU660 < 4) or (RU660 > 999) then exit; 
  Row:=RU660 mod 32 ;
  If (Row > 3) And (Row < 20) then
  Begin
    Kol:=RU660 div 32;
    While Kol > 7 do Dec(Kol,8);
    If (Kol >=0) and (Kol < 8) then
    Begin
      If (Row > 11) then Dec(Row,8) else Result.Rc5Type:=1;
      Result.Command:=RU660ToRc5Commands[Row,Kol];
      Result.ErrorCode:=0;
      Result.Toggle:=-1;   //alter before sending
      Result.Address:=-1;  //alter before sending
    End;
  End;
End;

//Progamming codes for he PHILIPS universal remote control sbc RU660/00
Function Rc5CommandToRU660(Rc5:TRc5Code):Integer;StdCall;
Begin
  Result:=-1;
  if Rc5.ErrorCode < 0 then exit;
  if (Rc5.Command < 0) or (Rc5.Command > 127) then exit;
  Result:=Rc5ToRU660Commands[Rc5.Command];
  if Rc5.Rc5Type = 0 then Inc(Result,8);
End;



Function Rc5ToIrEvent(Rc5Code:TRc5Code):TIrEvent;StdCall;
Var T:Integer;
Begin
  Result:=IrEventEmpty;
  Result[0]:=1;
  Result[1]:=0;
  if Rc5Code.Rc5Type = 0 then
  Begin
    Result[2]:=1;
    Result[3]:=0;
  end;
  if Rc5Code.Rc5Type = 0 then
  Begin
    Result[2]:=0;
    Result[3]:=1;
  end;
  Result[4]:=Rc5Code.Toggle;
  Result[5]:=integer(not Rc5Code.Toggle);
  For T:=1 to 5 do
  Begin
    Result[T*2+4]:=Integer(Odd(Rc5Code.Address));
    Result[T*2+5]:=Integer(not Odd(Rc5Code.Address));
    Rc5Code.Address:=(Rc5Code.Address shr 1);
  End;
  For T:=1 to 6 do
  Begin
    Result[T*2+14]:=Integer(Odd(Rc5Code.Command));
    Result[T*2+15]:=Integer(not Odd(Rc5Code.Command));
    Rc5Code.Command:=(Rc5Code.Command shr 1);
  End;
End;

Function IrEventToRc5(IrEvent:TIrEvent):TRc5Code;StdCall;
Var T:Integer;
Begin
  Result:=Rc5Empty;
  result.ErrorCode:=-3;
  if ((IrEvent[0] = 1) and
     (IrEvent[1] = 0) and
     (IrEvent[2] = 1) and
     (IrEvent[3] = 0))
     or
     ((IrEvent[0] = 1) and
     (IrEvent[1] = 0) and
     (IrEvent[2] = 0) and
     (IrEvent[3] = 1)) then
  Begin
    if (IrEvent[2] = 0) and (IrEvent[3] = 1) then Result.Rc5Type:=1;
    if IrEvent[4] <> IrEvent[5] then Result.Toggle:=IrEvent[4] else exit;

    For T:=1 to 5 do
    Begin
      if IrEvent[T*2+4] <> IrEvent[T*2+5] then
      Begin
        Result.Address:=Result.Address shl 1;
        inc(Result.Address,IrEvent[T*2+4]);
      End else exit;
    End;

    For T:=1 to 6 do
    Begin
      if IrEvent[T*2+14] <> IrEvent[T*2+15] then
      Begin
        Result.Command:=Result.Command shl 1;
        inc(Result.Command,IrEvent[T*2+14]);
      End else exit;
    End;

  End else exit;
  Result.ErrorCode:=0;
End;

Function WaitIrEvent(Var IrEvent:TIrEvent;TimeOut:DWord):Boolean;StdCall;
Var StartBit,NeverStop:Boolean;
    BitTeller:Integer;
    TimeOutTimer:DWORD;

Begin
  Result:=False;
  if not CommOpen then exit;

  TimeOuttimer:=GetTickCount+TimeOut;
  if TimeOut = INFINITE then NeverStop:=True else NeverStop:=False;

  QueryPerformanceFrequency(Frec);
  StartBit:=False;
  BitTeller:=0;
  While Not StartBit do  // Wacht op Startbits  bit 1 en 2
  Begin
    While (CTSLine = 1) do
    Begin
      if (Not NeverStop) and (TimeOutTimer <= GetTickCount) then exit;  //TimeOut
    End;
    QueryPerformanceCounter(PrevCount);
    IrDelay(Rc5QbitTime);
    if (CTSLine = 0) and (BitTeller =0) then
    Begin
      Inc(BitTeller);
      IrDelay(Rc5HalfbitTime);
      if  CTSLine = 1 then
      Begin
        IrDelay(Rc5HalfbitTime);
        if CTSLine = 0 then StartBit:=True;
        IrEvent[0]:=1;
        IrEvent[1]:=0;
        IrEvent[2]:=1;
        IrEvent[3]:=0;
      End Else
      Begin
        IrDelay(Rc5HalfbitTime);
        if CTSLine = 1 then StartBit:=True;
        IrEvent[0]:=1;
        IrEvent[1]:=0;
        IrEvent[2]:=0;
        IrEvent[3]:=1;
      End;
    End;
  End;
  For BitTeller:=4 to 27 do
  Begin
    IrDelay(Rc5HalfBitTime);
    IrEvent[BitTeller]:=CTSLine;
  End;
  Result:=True;
End;


Function GetNextRc5Bit(Var Rc5Bit:Integer):Boolean; //Niet in gebruik
Begin
  Rc5Bit:=CTSLine;
  IrDelay(Rc5HalfBitTime);
  if CTSLine <> Rc5Bit then Result:=True else Result:=False;
End;


Function WaitRc5CodeEvent(Var Code:TRc5Code;TimeOut:DWORD):Boolean;StdCall;
Var StartBit,NeverStop:Boolean;
    BitTeller,T,NextBit:Integer;
    TimeOutTimer:DWORD;

Begin
  Result:=False;
  Code:=Rc5Empty;   //Port not open
  if not CommOpen then exit;

  Code.ErrorCode:=-2; //TimeOut
  TimeOuttimer:=GetTickCount+TimeOut;
  if TimeOut = INFINITE then NeverStop:=True else NeverStop:=False;

  QueryPerformanceFrequency(Frec);
  StartBit:=False;
  T:=0;
  While Not StartBit do  // Wacht op Startbits  bit 1 en 2
  Begin
    While (CTSLine = 1) do
    Begin
      if (Not NeverStop) and (TimeOutTimer <= GetTickCount) then exit;  //TimeOut
    End;
    QueryPerformanceCounter(PrevCount);
    IrDelay(Rc5QbitTime);
    if (CTSLine = 0) and (T = 0) then
    Begin
      inc(T);
      IrDelay(Rc5HalfBitTime);
      if  CTSLine = 1 then
      Begin
        IrDelay(Rc5HalfBitTime);
        if CTSLine = 0 then StartBit:=True;
        //Code.Rc5Type:=0;
      End Else
      Begin
        IrDelay(Rc5HalfbitTime);
        if CTSLine = 1 then StartBit:=True;
        Code.Rc5Type:=1;
      End;
    End;
  End;
  Code.ErrorCode:=-3;//RC5 code not complete

  IrDelay(Rc5HalfBitTime);
  Code.Toggle:=CTSLine;       // Toggle bit zelfde toets vaker ?
  IrDelay(Rc5HalfBitTime);
  if CTSLine = Code.Toggle then exit;   //RC5 code not complete

  For BitTeller:=1 to 5 do         //welk address ? 5 bits
  Begin
    IrDelay(Rc5HalfBitTime);
    NextBit:=CTSLine;
    IrDelay(Rc5HalfBitTime);
    if CTSLine = NextBit then exit;  //RC5 code not complete
    Code.Address:=Code.Address shl 1;
    inc(Code.Address,NextBit);
  end;

  For BitTeller:=1 to 6 do          // welk commando ? 6 bits
  Begin
    IrDelay(Rc5HalfBitTime);
    NextBit:=CTSLine;
    IrDelay(Rc5HalfBitTime);
    if CTSLine = NextBit then exit;   //RC5 code not complete
    Code.Command:=Code.Command shl 1;
    inc(Code.Command,NextBit);
  end;

  Code.ErrorCode:=0;   //Geen fouten 14 bits ontvangen
  Result:=True;
End;


Function OpenRC5Commport(CommPort:PChar):Integer;StdCall;
Var dcbCommPort:TDCB;
Begin
  if CommOpen then CloseHandle(CommHandle);
  CommOpen:=False;
  CommHandle:=CreateFile(CommPort,GENERIC_READ or GENERIC_WRITE,0,Nil,OPEN_EXISTING,0,0);
  if CommHandle = INVALID_HANDLE_VALUE then
  Begin
    Result:=-1;
    Exit;
  End;
  dcbCommPort.DCBlength := SizeOf(TDcb);
  if not GetCommState(CommHandle, dcbCommPort) then
  Begin
    Result:=-2;
    CloseHandle(CommHandle);
    exit;
  end;
  dcbCommPort.Flags:=(dcbCommPort.Flags or fDtrControlEnable);
  dcbCommPort.Flags:=(dcbCommPort.Flags or fRtsControlEnable);
  dcbCommPort.Flags:=(dcbCommPort.Flags and not (fDtrControlEnable * 2));
  dcbCommPort.Flags:=(dcbCommPort.Flags and not (fRtsControlEnable * 2));
  if not SetCommState(CommHandle,dcbCommPort) then
  Begin
    result:=-3;
    CloseHandle(CommHandle);
    exit;
  end;
  Result:=0;
  CommOpen:=True;
End;

Function CloseRC5Commport:Integer;StdCall;
Var dcbCommPort:TDCB;
Begin
  Result:=0;
  if not CommOpen then exit;
  dcbCommPort.DCBlength := SizeOf(TDcb);
  GetCommState(CommHandle, dcbCommPort);
  dcbCommPort.Flags:=(dcbCommPort.Flags and not fDtrControlEnable);
  dcbCommPort.Flags:=(dcbCommPort.Flags and not fRtsControlEnable);
  dcbCommPort.Flags:=(dcbCommPort.Flags and not (fDtrControlEnable * 2));
  dcbCommPort.Flags:=(dcbCommPort.Flags and not (fRtsControlEnable * 2));
  SetCommState(CommHandle,dcbCommPort);
  CloseHandle(CommHandle);
  CommOpen:=False;
End;

////!!!!!!!!!!!!!!   not tested
Function SendIrEvent(IrEvent:TIrEvent):Integer;StdCall;
Var T:Integer;
Begin
  Result:=0;
  QueryPerformanceFrequency(Frec);
  QueryPerformanceCounter(PrevCount);
  For T:=0 to 27 do
  Begin
    TXDLine(CommHandle,IrEvent[T]);
    IrDelay(Rc5HalfBitTime);
  End;
  TXDLine(CommHandle,0);
End;

Function SendRc5Code(Rc5Code:TRc5Code):Integer;StdCall;
Begin
  Result:=SendIrEvent(Rc5ToIrEvent(Rc5Code));
End;
//!!!!!!!!!!!!!!!!!!!!

Exports
  WaitRc5CodeEvent,
  OpenRC5Commport,
  CloseRC5Commport,
  InitIrDelay,
  IrDelay,
  WaitIrEvent,
  IrEventToRc5,
  Rc5ToIrEvent,
  RU660ToRc5Command,
  Rc5CommandToRU660;
  //SendIrEvent,
  //SendRc5Code;

const
  DLL_PROCESS_DETACH = 0;
  DLL_PROCESS_ATTACH = 1;
  DLL_THREAD_ATTACH  = 2;
  DLL_THREAD_DETACH  = 3;

Procedure DLLMain(dwReason:DWORD);
Begin
  Case dwReason of
  DLL_PROCESS_DETACH:Begin
                       if CommOpen then CloseHandle(CommHandle);
                     End;
  DLL_PROCESS_ATTACH:Begin
                     End;
  End;
End;

Begin
  DLLProc:=@DLLMain;
  DLLMain(DLL_PROCESS_ATTACH);
End.


