unit Rc5DLL;
//Interface unit to the Rc5Com.DLL
//By E.L. Lagerburg januari 2002.

interface
Uses Windows;

Type TRc5Code = Record
                case integer of
                0:(
                  ErrorCode:Integer;
                  Rc5Type:Integer;
                  Toggle:Integer;
                  Address:Integer;
                  Command:Integer;
                  );
                1:(
                  Chars:Array[0..19] of char;
                  );
                End;

Type PRc5Code = ^TRc5Code;


Type TIrEvent = Array[0..27] of Integer;
Type PIrEvent = ^TIrEvent;

//Functions in Rc5Com.DLL
Function OpenRC5Commport(CommPort:PChar):Integer;StdCall;
Function CloseRC5Commport:Integer;StdCall;

Function WaitRc5CodeEvent(Var Code:TRc5Code;TimeOut:DWORD):Boolean;StdCall;
Function WaitIrEvent(Var IrEvent:TIrEvent;TimeOut:DWord):Boolean;StdCall;

Function IrEventToRc5(IrEvent:TIrEvent):TRc5Code;StdCall;
Function Rc5ToIrEvent(Rc5Code:TRc5Code):TIrEvent;StdCall;

//Progamming codes for he PHILIPS Remote Control sbc RU660/00
Function RU660ToRc5Command(RU660:Integer):TRc5Code;StdCall;
Function Rc5CommandToRU660(Rc5:TRc5Code):Integer;StdCall;
//Programming PHILIPS Remote Control sbc RU660/00
//Press mode selector to select the categorie to programm for TV,VCR,SAT ...
//Press and hold the key 1 and the 6 at the same time for about 3 seconds
//until greed led light up
//Press 9 9 4
//enter 3 digit command code (see functions above / not the same as Rc5 command code)
//Press the key to programm
//does not override macro's so delete this first for the key to program



//Local functions
Function OpenRC5ReadThread(CommPort:PChar;aWndHandle:Hwnd;aWndCommand:UINT):Integer;
Function CloseRc5ReadThread:Integer;
Function IrEventToStr(IrEvent:TIrEvent):String;
Function Rc5CodeToStr(Rc5Code:TRc5Code):String;

Const C_START        = 1; // begin ReadThread
Const C_Rc5_READ     = 2; // TRc5Code received
Const C_END          = 3; // end ReadThread
Const C_TIMEOUT      = 4; // not in use
Const C_IrEvent_READ = 5; // TIrEvent received

Const F_Rc5     = 0;
Const F_IrEvent = 1;
Const WaitFunc :Integer = F_Rc5; //Select Waitfunction

implementation
Uses SysUtils;

Const WHandle:Hwnd = 0;
Const WCommand:UINT = 0;
Const  WM_USER = $0400;
Const RC5 = 'Rc5Com.DLL';
Const OpenRc5Thread:Boolean = False;

Var Port:String;
Var SecRc5Read,SecParamRead:TRTLCriticalSection;
Var ReadRc5Thread:Integer;
Var ThreadId:DWORD;
Var RunningReadThread:Boolean;


Function doRunThread:Boolean;
Begin
  EnterCriticalSection(SecRc5Read);
  Result:=RunningReadThread;
  LeaveCriticalSection(SecRc5Read);
End;


Function Rc5_ReadThread_Handler(Param:Pointer):Longint;StdCall;
var aWHandle:Hwnd;
    aWCommand:UINT;
    Rc5Code:TRc5Code;
    IrEvent:TIrEvent;
Begin
  EnterCriticalSection(SecParamRead);
  aWHandle:=WHandle;
  aWCommand:=WCommand;
  LeaveCriticalSection(SecParamRead);
  SendMessage(aWHandle,aWCommand,C_START,0);
  OpenRC5Commport(PChar(Port));
  While doRunThread do
  Begin
    Case WaitFunc of
    F_Rc5:Begin
            if WaitRc5CodeEvent(Rc5Code,500) then
            Begin
              if doRunThread then
              Begin
                SendMessage(aWHandle,aWCommand,C_Rc5_READ,LPARAM(@Rc5Code));
              end;
            End;
          End;
    F_IrEvent:Begin
                if WaitIrEvent(IrEvent,500) then
                Begin
                  if doRunThread then
                  Begin
                    SendMessage(aWHandle,aWCommand,C_IrEvent_READ,LPARAM(@IrEvent));
                  end;
                End;
              End;
    End;
  End;
  Result:=0;
End;

Function OpenRC5ReadThread(CommPort:PChar;aWndHandle:Hwnd;aWndCommand:UINT):Integer;
Begin
  Result:=-1;
  if OpenRc5Thread then exit;
  Port:=CommPort;
  InitializeCriticalSection(SecRc5Read);
  InitializeCriticalSection(SecParamRead);
  EnterCriticalSection(SecRc5Read);
  RunningReadThread:=False;
  LeaveCriticalSection(SecRc5Read);
  if ((aWndHandle <> 0) and (aWndCommand > WM_USER)) then
  Begin
    EnterCriticalSection(SecParamRead);
    WHandle:=aWndHandle;
    WCommand:=aWndCommand;
    LeaveCriticalSection(SecParamRead);
    EnterCriticalSection(SecRc5Read);
    RunningReadThread:=True;
    LeaveCriticalSection(SecRc5Read);
    ReadRc5Thread:=CreateThread(nil,0,@Rc5_ReadThread_Handler,nil,0,ThreadId);
    if ReadRc5Thread = 0 then
    Begin
      EnterCriticalSection(SecRc5Read);
      RunningReadThread:=False;
      LeaveCriticalSection(SecRc5Read);
      Exit;
    End;
    SetThreadPriority(ReadRc5Thread,THREAD_PRIORITY_HIGHEST);
    Result:=0;
    OpenRc5Thread:=True;
  End;
End;

Function CloseRc5ReadThread:Integer;
Begin
  if OpenRc5Thread then
  Begin
    EnterCriticalSection(SecRc5Read);
    RunningReadThread:=False;
    LeaveCriticalSection(SecRc5Read);
    WaitForSingleObject(ReadRc5Thread,INFINITE);
    CloseHandle(ReadRc5Thread);
    CloseRC5Commport;
    SendMessage(WHandle,WCommand,C_END,0);
    DeleteCriticalSection(SecRc5Read);
    DeleteCriticalSection(SecParamRead);
    Result:=0;
    OpenRc5Thread:=False;
  end else Result:=-1;
End;

Function Rc5Equal(C1,C2:TRc5Code):Boolean;
Begin
  if c1.Chars = c2.Chars then result:=true else result:=False;
End;

Function IrEventToStr(IrEvent:TIrEvent):String;
Var T:Integer;
Begin
  Result:='';
  For T:=0 to 27 do
  Begin
    if (T > 0) and (not odd(T)) then Result:=Result+'/';
    if IrEvent[T] = 0 then Result:=Result+'0' else
     if IrEvent[T] = 1 then Result:=Result+'1' else
      Result:=Result+'?';
  end;
end;

Function Rc5CodeToStr(Rc5Code:TRc5Code):String;
Begin
  If Rc5Code.ErrorCode = 0 then
  Begin
    Result:=IntToStr(Rc5Code.Rc5Type)+'/'+IntToStr(Rc5Code.Toggle)+'/'+IntToStr(Rc5Code.Address)+'/'+IntToStr(Rc5Code.Command);
  End else Result:='Error '+IntToStr(Rc5Code.ErrorCode);
End;

Function OpenRC5Commport;External RC5;
Function CloseRC5Commport;External RC5;
Function WaitRc5CodeEvent;External RC5;
Function WaitIrEvent;External RC5;
Function IrEventToRc5;External RC5;
Function Rc5ToIrEvent;External RC5;
Function RU660ToRc5Command;External RC5;
Function Rc5CommandToRU660;External RC5;

end.
